<!DOCTYPE html>
<html>
<head>
  <meta charset="utf-8">
  <title>kbd-crowd</title>
  <script>
  var ws;

  function keyEvent(down, event) {
    event.preventDefault();
    code = {key: event.key, down: down}
    ws.send(JSON.stringify(code))
  }

  window.addEventListener("load", function(evt) {
    ws = new WebSocket("{{.}}");
    ws.onopen = function(evt) {
      document.addEventListener('keydown', (event) => {keyEvent(true, event)}, false);
      document.addEventListener('keyup', (event) => {keyEvent(false, event)}, false);
    }
    ws.onclose = function(evt) {
      ws = null;
    }
    ws.onmessage = function(evt) {
      keys = JSON.parse(evt.data)
      console.log(keys);
      target = document.getElementById('keys');
      target.innerHTML = '';
      for (i = 0; i < keys.length; i++) {
        if (keys[i] == ' ') {
          keys[i] = 'SPACE';
        }
        target.innerHTML += '<kbd>' + keys[i].toLowerCase() + '</kbd> ';
      }
    }
    ws.onerror = function(evt) {
      alert(evt.data);
    }
  });
  </script>
  <style>
    kbd {
        background-color: lightgrey;
        color: black;
        margin: 2px;
        padding: 2px;
        border-radius: 2px;
    }
  </style>
</head>
<body>
  <h1>Beunen kbd-crowd</h1>
  <h2>You now control the keyboard</h2>
  <p>
    Your keys are: <span id="keys"></span>.
  </p>
</body>
</html>
